package com.usky.iot.service.impl;

import com.usky.common.security.utils.SecurityUtils;
import com.usky.iot.domain.CrmCustomRemind;
import com.usky.iot.mapper.CrmCustomRemindMapper;
import com.usky.iot.service.CrmCustomRemindService;
import com.usky.common.mybatis.core.AbstractCrudService;
import org.springframework.stereotype.Service;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsRequest;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsResponse;
import com.aliyuncs.exceptions.ClientException;
import com.aliyuncs.profile.DefaultProfile;
import com.google.gson.Gson;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Random;

/**
 * <p>
 * 客户提醒信息表 服务实现类
 * </p>
 *
 * @author han
 * @since 2023-06-27
 */
@Service
public class CrmCustomRemindServiceImpl extends AbstractCrudService<CrmCustomRemindMapper, CrmCustomRemind> implements CrmCustomRemindService {

    @Override
    public void add(CrmCustomRemind crmCustomRemind){
        String method = crmCustomRemind.getRemindMethod();
        StringBuffer sendStatus = new StringBuffer();
        //发送短信
        DefaultProfile profile = DefaultProfile.getProfile("cn-beijing", "LTAI9WERPIFIlHDg", "p7SQ0rYpraebcdoJ0l3tOtYmmgrR4q");
        IAcsClient client = new DefaultAcsClient(profile);
        SendSmsRequest request = new SendSmsRequest();
        request.setPhoneNumbers(crmCustomRemind.getPhone());//接收短信的手机号码
        request.setSignName("永天智慧云");//短信签名名称
        request.setTemplateCode("SMS_164095840");//短信模板CODE
        String code = "test";
        request.setTemplateParam("{\"code\":\""+code+"\"}");//短信模板变量对应的实际值
        try {
            SendSmsResponse response = client.getAcsResponse(request);
            if(response.getCode() != null){
                if(response.getCode().equals("OK")){
                    sendStatus.append("1");
                }else{
                    sendStatus.append("2");
                }
            }
            System.out.println(new Gson().toJson(response));
        } catch (ClientException e) {
            System.out.println("ErrCode:" + e.getErrCode());
            System.out.println("ErrMsg:" + e.getErrMsg());
            System.out.println("RequestId:" + e.getRequestId());
        }

        crmCustomRemind.setSendStatus(sendStatus.toString());  //发送状态需要根据发送返回结果确认
        crmCustomRemind.setSendTime(LocalDateTime.now());
        crmCustomRemind.setCreateBy(SecurityUtils.getUsername());
        crmCustomRemind.setCreateTime(LocalDateTime.now());
        crmCustomRemind.setTenantId(SecurityUtils.getTenantId());
        this.save(crmCustomRemind);
    }

}
